Chapter 3 Oracle Examples

4.1
SELECT StdFirstName, StdLastName, StdCity, StdGPA
  FROM Student
  WHERE StdGPA >= 3.7
 /

4.2
SELECT * FROM Faculty
/

4.3
SELECT FacFirstName, FacLastName, FacCity, 
       FacSalary*1.1 AS IncreasedSalary, FacHireDate 
 FROM Faculty 
 WHERE to_number(to_char(FacHireDate, 'YYYY' ) ) > 1996
/

4.4
SELECT * 
 FROM Course 
 WHERE CourseNo LIKE 'IS4%'
/

4.5
SELECT FacFirstName, FacLastName, FacHireDate 
 FROM Faculty 
 WHERE FacHireDate BETWEEN '1-Jan-1999' AND '31-Dec-2000'
/

4.6
SELECT OfferNo, CourseNo 
 FROM Offering 
 WHERE FacSSN IS NULL AND OffTerm = 'SUMMER' 
   AND OffYear = 2006
/

4.7
SELECT OfferNo, CourseNo, FacSSN 
 FROM Offering 
 WHERE (OffTerm = 'FALL' AND OffYear = 2005) 
    OR (OffTerm = 'WINTER' AND OffYear = 2006)
/

4.8
SELECT OfferNo, Offering.CourseNo, OffDays, OffTime 
 FROM Offering, Course 
 WHERE OffTerm = 'SPRING' AND OffYear = 2006
   AND (CrsDesc LIKE '%DATABASE%' 
    OR CrsDesc LIKE '%PROGRAMMING%') 
   AND Course.CourseNo = Offering.CourseNo
/

4.9
SELECT OfferNo, CourseNo, FacFirstName, FacLastName 
 FROM Offering, Faculty 
 WHERE OffTerm = 'FALL' AND OffYear = 2005 
   AND FacRank = 'ASST' AND CourseNo LIKE 'IS%'
   AND Faculty.FacSSN = Offering.FacSSN
/

4.10 (Oracle 9i and later versions only)
SELECT OfferNo, CourseNo, FacFirstName, FacLastName  
 FROM Offering INNER JOIN Faculty 
   ON Faculty.FacSSN = Offering.FacSSN
 WHERE OffTerm = 'FALL' AND OffYear = 2005 
   AND FacRank = 'ASST' AND CourseNo LIKE 'IS*'
/

4.11
SELECT StdMajor, AVG(StdGPA) AS AvgGPA
 FROM Student 
 GROUP BY StdMajor
/

4.12
SELECT OffYear, COUNT(*) AS NumOfferings, 
       COUNT(DISTINCT CourseNo) AS NumCourses
 FROM Offering
 GROUP BY OffYear
/

4.13
SELECT StdMajor, AVG(StdGPA) AS AvgGpa 
 FROM Student 
 WHERE StdClass = 'JR' OR StdClass = 'SR'
 GROUP BY StdMajor
/

4.14
SELECT StdMajor, AVG(StdGPA) AS AvgGpa 
 FROM Student 
 WHERE StdClass IN ('JR', 'SR')
 GROUP BY StdMajor 
 HAVING AVG(StdGPA) > 3.1 
/

4.15
SELECT COUNT(*) AS StdCnt, AVG(StdGPA) AS AvgGPA 
 FROM Student 
 WHERE StdClass = 'JR' OR StdClass = 'SR'
/

4.16
SELECT StdMajor, StdClass, MIN(StdGPA) AS MinGPA, 
       MAX(StdGPA) AS MaxGPA 
 FROM Student 
 GROUP BY StdMajor, StdClass
/

4.17
SELECT CrsDesc, COUNT(*) AS OfferCount 
 FROM Course, Offering  
 WHERE Course.CourseNo = Offering.CourseNo 
   AND Course.CourseNo LIKE 'IS%'  
 GROUP BY CrsDesc 
/

4.18
SELECT StdGPA, StdFirstName, StdLastName, StdCity,
       StdState 
 FROM Student 
 WHERE StdClass = 'JR'
 ORDER BY StdGPA
/

4.19
SELECT FacRank, FacSalary, FacFirstName, FacLastName,
       FacDept 
 FROM Faculty 
 ORDER BY FacRank, FacSalary DESC
/

4.20
SELECT FacCity, FacState 
  FROM Faculty
/

4.21
SELECT DISTINCT FacCity, FacState 
 FROM Faculty
/

4.22
SELECT CourseNo, Enrollment.OfferNo, 
       AVG(EnrGrade) AS AvgGrade
 FROM Enrollment, Offering
 WHERE CourseNo LIKE 'IS%' AND OffYear = 2005 
   AND OffTerm = 'FALL' 
   AND Enrollment.OfferNo = Offering.OfferNo
 GROUP BY CourseNo, Enrollment.OfferNo
 HAVING  COUNT(*) > 1
 ORDER BY CourseNo, 3 DESC
/

4.23
SELECT StdFirstName, StdLastName, OfferNo, EnrGrade 
 FROM Student, Enrollment 
 WHERE EnrGrade >= 3.5 
   AND Student.StdSSN = Enrollment.StdSSN
/

4.24
SELECT StdFirstName, StdLastName 
 FROM Student, Enrollment 
 WHERE EnrGrade >= 3.5 
   AND Student.StdSSN = Enrollment.StdSSN
/

4.25
SELECT DISTINCT StdFirstName, StdLastName 
 FROM Student, Enrollment 
 WHERE EnrGrade >= 3.5 
   AND Student.StdSSN = Enrollment.StdSSN
/

4.26
SELECT StdFirstName, StdLastName, Enrollment.OfferNo 
 FROM Student, Enrollment, Offering 
 WHERE Student.StdSSN = Enrollment.StdSSN
   AND Offering.OfferNo =  Enrollment.OfferNo 
   AND OffYear = 2005 AND OffTerm = 'FALL'  
   AND EnrGrade >= 3.7
/

4.27
SELECT OfferNo, Offering.CourseNo, CrsUnits, OffDays,
       OffLocation, OffTime
 FROM Faculty, Course, Offering 
 WHERE Faculty.FacSSN = Offering.FacSSN
   AND Offering.CourseNo = Course.CourseNo 
   AND OffYear = 2005 AND OffTerm = 'FALL'  
   AND FacFirstName = 'LEONARD' 
   AND FacLastName = 'VINCE'
/

4.28
SELECT Offering.OfferNo, Offering.CourseNo, OffDays,
       OffLocation, OffTime, FacFirstName, FacLastName
 FROM Faculty, Offering, Enrollment, Student 
 WHERE Offering.OfferNo = Enrollment.OfferNo
   AND Student.StdSSN = Enrollment.StdSSN 
   AND Faculty.FacSSN = Offering.FacSSN 
   AND OffYear = 2006 AND OffTerm = 'SPRING' 
   AND StdFirstName = 'BOB' 
   AND StdLastName = 'NORBERT'
/

4.29
SELECT Offering.OfferNo, Offering.CourseNo, OffDays,
       OffLocation, OffTime, CrsUnits, FacFirstName,
       FacLastName
 FROM Faculty, Offering, Enrollment, Student, Course
 WHERE Faculty.FacSSN = Offering.FacSSN 
   AND Offering.OfferNo = Enrollment.OfferNo
   AND Student.StdSSN = Enrollment.StdSSN
   AND Offering.CourseNo = Course.CourseNo
   AND OffYear = 2006 AND OffTerm = 'SPRING' 
   AND StdFirstName = 'BOB'
   AND StdLastName = 'NORBERT'
/

4.30
SELECT Student.* 
 FROM Student, Faculty 
 WHERE StdSSN = FacSSN
/

4.31 (Oracle 9i and later versions only)
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM Student INNER JOIN Enrollment 
   ON Student.StdSSN = Enrollment.StdSSN
 WHERE EnrGrade >= 3.5

4.32 (Oracle 9i and later versions only)
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM ( Student INNER JOIN Enrollment 
     ON Student.StdSSN = Enrollment.StdSSN )
  INNER JOIN Offering
    ON Offering.OfferNo = Enrollment.OfferNo
 WHERE EnrGrade >= 3.5 AND OffTerm = 'FALL' 
   AND OffYear = 2005
/

4.33 (Oracle 9i and later versions only)
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM ( (Student INNER JOIN Enrollment 
       ON Student.StdSSN = Enrollment.StdSSN )
  INNER JOIN Offering 
     ON Offering.OfferNo = Enrollment.OfferNo )
  INNER JOIN Faculty ON Faculty.FacSSN = Offering.FacSSN
 WHERE EnrGrade >= 3.5 AND OffTerm = 'FALL' 
   AND OffYear = 2005 AND FacFirstName = 'LEONARD'
   AND FacLastName = 'VINCE'
/

4.34 (Oracle 9i and later versions only)

SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM ( (Student INNER JOIN Enrollment 
    ON Student.StdSSN = Enrollment.StdSSN )
   INNER JOIN Offering 
    ON Offering.OfferNo = Enrollment.OfferNo ), 
   Faculty
 WHERE EnrGrade >= 3.5 AND OffTerm = 'FALL' 
   AND OffYear = 2005 AND FacFirstName = 'LEONARD'
   AND FacLastName =  'VINCE'
   AND Faculty.FacSSN = Offering.FacSSN
/

4.35
SELECT Subr.FacSSN, Subr.FacLastName, Subr.FacSalary, 
       Supr.FacSSN, Supr.FacLastName, Supr.FacSalary
 FROM Faculty Subr, Faculty Supr
 WHERE Subr.FacSupervisor = Supr.FacSSN 
   AND Subr.FacSalary > Supr.FacSalary
/

4.36
SELECT FacFirstName, FacLastName, O1.CourseNo
 FROM Faculty, Offering O1, Offering O2
 WHERE Faculty.FacSSN = O1.FacSSN 
   AND Faculty.FacSupervisor = O2.FacSSN 
   AND O1.OffYear = 2006 AND O2.OffYear = 2006 
   AND O1.CourseNo = O2.CourseNo
/

4.37
SELECT CourseNo, Enrollment.OfferNo, 
       Count(*) AS NumStudents
 FROM Offering, Enrollment
 WHERE Offering.OfferNo = Enrollment.OfferNo
   AND OffYear = 2006 AND OffTerm = 'SPRING' 
 GROUP BY Enrollment.OfferNo, CourseNo
/

4.38
SELECT CourseNo, Enrollment.OfferNo, Avg(StdGPA) AS AvgGPA
 FROM Student, Offering, Enrollment
 WHERE Offering.OfferNo = Enrollment.OfferNo
   AND Enrollment.StdSSN = Student.StdSSN 
   AND OffYear = 2005 AND OffTerm = 'FALL' 
 GROUP BY CourseNo, Enrollment.OfferNo 
 HAVING Avg(StdGPA) > 3.0
/

4.39
SELECT FacSSN AS SSN, FacFirstName AS FirstName,
       FacLastName AS LastName, FacCity AS City, 
       FacState AS State 
 FROM Faculty
	UNION 
SELECT StdSSN AS SSN, StdFirstName AS FirstName,
       StdLastName AS LastName, StdCity AS City, 
       StdState AS State 
 FROM Student
/

4.40
SELECT FacSSN AS SSN, FacFirstName AS FirstName, 
       FacLastName AS LastName, FacCity AS City, 
       FacState AS State 
 FROM Faculty
   INTERSECT
SELECT StdSSN AS SSN, StdFirstName AS FirstName, 
       StdLastName AS LastName, StdCity AS City, 
       StdState AS State 
 FROM Student
/

4.41
SELECT FacSSN AS SSN, FacFirstName AS FirstName, 
       FacLastName AS LastName, FacCity AS City, 
       FacState AS State 
 FROM Faculty
     MINUS
SELECT StdSSN AS SSN, StdFirstName AS FirstName, 
       StdLastName AS LastName, StdCity AS City, 
       StdState AS State 
 FROM Student
/

4.42
INSERT INTO Student 
 (StdSSN, StdFirstName, StdLastName, 
  StdCity, StdState, StdZip, StdClass, StdMajor, StdGPA) 
 VALUES ('999999999', 'JOE', 'STUDENT', 'SEATAC', 
         'WA', '98042-1121', 'FR', 'IS', 0.0)
/

4.43 (This query assumes that you have created a new table (ISStudent) with the same columns as Student.
INSERT INTO ISStudent 
 SELECT * FROM Student WHERE StdMajor = 'IS'
/

4.44
UPDATE Faculty 
 SET FacSalary = FacSalary * 1.1 
 WHERE FacDept = 'MS'
/

4.45
UPDATE Student 
 SET StdMajor = 'ACCT', StdClass = 'SO' 
 WHERE StdFirstName = 'HOMER' 
   AND StdLastName = 'WELLS'
/

4.46
DELETE FROM Student 
 WHERE StdMajor = 'IS' AND StdClass = 'SR'
/

4.47 (This query assumes that you have created a new table (ISStudent) with the same 
columns as Student.

DELETE FROM ISStudent
/


